package GrabInfo ;

use strict ;
use GrabInfo::VServer ;
use GrabInfo::Plugin ;
use GrabInfo::Plugin::_machine ;
use GrabInfo::Plugin::_hosts ;
use Data::Dumper ;
use Carp ;


$GrabInfo::VERSION = '1.60' ;
$GrabInfo::STREAM = \*STDOUT ;


sub new {
	my $class = shift ;
	my $context = shift ;
	
	my $this = {
		root => new GrabInfo::XMLTag("grabinfo"),
		context => $context,
	} ;
	bless($this, $class) ;

	$this->{root}->add_attr('mode', 'interactive') ;
	$this->{root}->add_attr('version', $GrabInfo::VERSION) ;
	return $this ;
}


sub snapshot {
	my $this = shift ;	

	# Global time for this session 
	$GrabInfo::TIME = time() ;

	# We create a dummy plugin just to go though
	# the children...
	my $pis = new GrabInfo::Plugin("snapshot", $this->{context}, 1) ;
	$pis->{xml_tag}->add_attr("time", $GrabInfo::TIME) ;

	my $pim = new GrabInfo::Plugin::_machine("_machine", $this->{context}, 2) ;
	$pim->run() ;
	$pis->{xml_tag}->add_kid($pim->{xml_tag}) ;

	my $pih = new GrabInfo::Plugin::_hosts("_hosts", $this->{context}, 2) ;
	$pih->run() ;
	$pis->{xml_tag}->add_kid($pih->{xml_tag}) ;

	$pis->{xml_tag}->add_attr("duration", time() - $GrabInfo::TIME) ;
	$this->{root}->add_kid($pis->{xml_tag}) ;
}


sub dump {
	my $this = shift ;

	$this->{root}->dump($GrabInfo::STREAM) ;
}


1 ;
