package GrabInfo::Plugin::_hosts::_addresses::_ip ;
@ISA = qw(GrabInfo::Plugin) ;

use strict ;
use Data::Dumper ;


sub iterate {
	my $this = shift ;

	my @ips = @{$this->get_context_data("iproot")} ;
	if (! scalar(@ips)){
		return () ;
	}

	# Get the netstat output and store it in the context
	if ($this->get_context_data("opt_netstat")){
		my $lines = $this->run_cmd("/bin/netstat -natp") ;
		if ($lines){
			my %ips = () ;
			foreach my $l (@{$lines}){
				my @c = split(/[\s:\/]+/, $l) ;
				my $proto = $c[0] ;
				if ($c[0] eq 'tcp'){
					my $type = $c[7] ;
					my $ip = $c[3] ;
					my $port = $c[4] ;
					my $exe = $c[9] ;
					if ($type eq "LISTEN"){
						my @ipl = ($ip) ;
						if ($ip eq '0.0.0.0'){
							@ipl = @ips ;
						}
						foreach my $i (@ipl){
							$ips{$i}->{$port}->{exe} = $exe ;
							$ips{$i}->{$port}->{nb_conn} = 0 ;
						}
					}
					elsif (($type eq "ESTABLISHED")&&(exists $ips{$ip}->{$port})){
						$ips{$ip}->{$port}->{nb_conn}++ ;
					}
				}
			}
			delete $ips{'127.0.0.1'} ;

			$this->set_context_data('ip_data', \%ips) ;
		}
	}

	return @ips ;
}


sub snapshot {
	my $this = shift ;
	my $addr = shift ;

	$this->{xml_tag}->add_attr("_addr", $addr) ;
	$this->set_context_data('ip', $addr) ;
}


1 ;

