package GrabInfo::Plugin::_machine::_proc ;
@ISA = qw(GrabInfo::Plugin) ;

use strict ;
use GrabInfo::VServer ;


sub run {
	my $this = shift ;

	if ((! GrabInfo::VServer::supported())||
		(GrabInfo::VServer::get_current_ctx() != 0)){
		# We don't support vservers or we are not in the root host.
		return $this->SUPER::run() ;
	}

	# What we want to do is fork ourselves to get into context 1
	# and execute from there.
	pipe(README, WRITEME) ;
	my $pid = fork() ;
	if (! defined($pid)){
		croak("Fork failed: $!") ;
	}
	elsif ($pid){
		close(WRITEME) ;
		my @lines = <README> ;
		close(README) ;

		$this->{xml_tag}->{raw} = \@lines ;

		waitpid($pid, 0) ;
	}
	else {
		# child
		close(README) ;

		$this->{xml_tag}->{indent} = 0 ;
		eval {
			# Get a new context
			GrabInfo::VServer::chcontext(-1) ;
			$this->SUPER::run() ;
		} ;
		if ($@){
			$this->{xml_tag}->add_error($@) ;
		}

		$this->{xml_tag}->dump(\*WRITEME) ;
		close(WRITEME) ;
		exit() ;
	}
}


sub snapshot {
}


1 ;

