package GrabInfo::Plugin::_machine::_static::cpus ;
@ISA = qw(GrabInfo::Plugin) ;

use strict ;


sub snapshot {
	my $this = shift ;

	my $lines = $this->slurp_file("/proc/cpuinfo") ;
	if ($lines){
		my $nb = 0 ;
		my $kid = undef ;
		foreach my $l (@{$lines}){
			$l =~ s/^\s+// ;
			$l =~ s/\s+$// ;
			my ($key, $val) = split(/\s*:\s*/, $l, 2) ;
			if ($key eq 'processor'){
				$nb++ ;
				$kid = $this->{xml_tag}->create_kid("cpu_" . ($nb - 1)) ;
				$this->{xml_tag}->add_kid($kid) ;
			}
			
			my %tags = (
				'cpu MHz' => 1,
				'vendor_id' => 1,
				'model name' => 1,
				'bogomips' => 1,
			) ;
			
			if (defined($kid)){
				if ($tags{$key}){
					$kid->add_attr($kid->validate_tag_name($key, 1), $val) ;
				}
			}
		}
		$this->{xml_tag}->add_attr('nb', $nb) ;
	}
}


1 ;
