package GrabInfo::Plugin::_machine::load ;
@ISA = qw(GrabInfo::Plugin) ;

use strict ;


sub snapshot {
	my $this = shift ;

	my $lines = $this->slurp_file("/proc/loadavg") ;
	if ($lines){
	 	my @vals = split(/\s+/, $lines->[0]) ;
		my $avg = $vals[1] ;
		my ($nbr, $nb) = split(/\//, $vals[3]) ;

		$this->{xml_tag}->add_attr('avg', $avg) ;
		$this->{xml_tag}->add_attr('nb_exist', $nb) ;
		$this->{xml_tag}->add_attr('nb_running', $nbr) ;
	}
}


1 ;


__END__

	# Now we want pass all the processes and grab some
	# stats on them
	# There are vservers on this machine
	if (opendir(DIR, "/proc/")){
		my @procs = grep {((-d "/proc/$_")&&($_ =~ /^\d+$/))} readdir DIR ;
		closedir(DIR) ;

		my $dummy = GrabInfo::Plugin->new('dummy', {}, 0) ;
		my %proc_info = () ;
		foreach my $p (@procs){
			# He we must be easy on the error handling because
			# processes can die at any time.
			my $lines = $dummy->slurp_file("/proc/$p/status") ;
			if ($lines){
				foreach my $l (@{$lines}){
					my @c = split(/\s+/, $l) ;
					if ($c[0] eq 'VmSize:'){
						$proc_info{$p}->{vmsize} = $c[1] * 1000 ;
					}
				}
			}
		}

		# Find maximums
		my %max = (
			vmsize => 0,
		) ;
		foreach my $p (@procs){
			foreach my $m (keys %max){
				if ($proc_info{$p}->{$m} > $max{$m}){
					$max{$m} = $proc_info{$p}->{$m} ;
				}
			}
		}

		$this->{xml_tag}->add_attr('mem_hogger', $max{vmsize}) ;
	}
	else {
		croak("Can't directory open /proc/ for reading: $!") ;
	}
}


1 ;
