package GrabInfo::Plugin::_machine::memory ;
@ISA = qw(GrabInfo::Plugin) ;

use strict ;


sub snapshot {
	my $this = shift ;

	my $lines = $this->slurp_file("/proc/meminfo") ;
	if ($lines){
		my @m = (split(/\s+/, $lines->[1])) ;
		shift @m ;
		my @s = (split(/\s+/, $lines->[2])) ;
		shift @s ;

		# Subtract buffers and cache
		$m[1] -= ($m[4] + $m[5]) ;
		$m[2] += ($m[4] + $m[5]) ;

		my $pm = sprintf("%.2f", ($m[0] ? $m[1] / $m[0] : 0) * 100) ;
		my $ps = sprintf("%.2f", ($s[0] ? $s[1] / $s[0] : 0) * 100) ;
	
		my $mk = $this->{xml_tag}->create_kid("ram") ;
		$mk->add_attr("percent_used", $pm) ;
		$this->{xml_tag}->add_kid($mk) ;
		my $sk = $this->{xml_tag}->create_kid("swap") ;
		$sk->add_attr("percent_used", $ps) ;
		$this->{xml_tag}->add_kid($sk) ;
	}
}


1 ;

