package GrabInfo::Plugin::_machine::raid ;
@ISA = qw(GrabInfo::Plugin) ;

use strict ;


sub snapshot {
	my $this = shift ;

	if (-e "/proc/mdstat"){
		my $lines = $this->slurp_file("/proc/mdstat") ;
		if ($lines){
			shift @{$lines} ;
			shift @{$lines} ;

			my %raids = () ;
			my $cur_raid = undef ;
			foreach my $l (@{$lines}){
				$l =~ s/^\s+// ;
				$l =~ s/\s+$// ;
				if ($l eq ''){
					next ;
				}
				elsif ($l =~ /^(\w+)\s+:\s+active\s+(.*)$/){
					$cur_raid = {} ;
					$raids{$1} = $cur_raid ;

					my @rest = split(/\s+/, $2) ;
					my $level = shift @rest ;
					$level =~ s/^raid// ;
					$cur_raid->{_level} = $level ;
					$cur_raid->{_nb_members} = scalar(@rest) ;
					$cur_raid->{_members} = join(' ', 
						map {$_ =~ s/\[(\d+)\]$// ; $_} sort by_raid_member @rest) ;
				}
				else {
					if ($l =~ /\[(.*?)\]\s+\[(.*?)\]/){
						my ($tot, $up) = split('/', $1) ;
						if ($tot > 0){
							my $old_tot = $cur_raid->{_nb_members} ;
							$cur_raid->{_nb_members} = $tot ;
							my $nbs = $old_tot - $tot ;
							if ($nbs){
								$cur_raid->{nb_spare} = $nbs ;
			 				}
							$cur_raid->{_up} = $2 ;
							$cur_raid->{percent_up} = int(($up / $tot) * 100) ;
						}
					}
				}
			}

			foreach my $r (sort keys %raids){
				my $kid = $this->{xml_tag}->create_kid($this->{xml_tag}->validate_tag_name($r, 1)) ;
				foreach my $k (keys %{$raids{$r}}){
					$kid->add_attr($k, $raids{$r}->{$k}) ;
				}
				$this->{xml_tag}->add_kid($kid) ;
			}
		}
	}
}


sub by_raid_member {
	$a =~ /\[(\d+)\]$/ ;
	my $nba = $1 ;
	$b =~ /\[(\d+)\]$/ ;
	my $nbb = $1 ;

	return $nba <=> $nbb ;
}


1 ;


