package GrabInfo::Service ;

use strict ;
use GrabInfo::WalkProc ;


sub new {
	my $class = shift ;
	my $plugin = shift ;
	
	my $this = {
		plugin => $plugin,
	} ;	
	
	bless($this, $class) ;
	return $this ;
}


sub test {
	my $this = shift ;
	my $xml_tag = shift ;
	my $args = shift ;
	my $timeout = shift ;

	my $status = 'ok' ;
	my $msg = 'OK' ;
	local $SIG{ALRM} = sub{die("timeout\n");} ;
	eval {
		alarm($timeout) ;
		$this->{plugin}->test($args) ;
		alarm(0) ;
	} ;
	if ($@){
		$status = 'error' ;
		if ($@ eq "timeout\n"){
			alarm(0) ;
			$msg = "Timeout occured after $timeout seconds" ;
		}
		else{
			$msg = $@ ;
		}
	}
	alarm(0) ;

	chomp($msg) ;
	$xml_tag->add_attr("status", $status) ;
	$xml_tag->add_attr("msg", $msg) ;
}


sub count_instances {
	my $this = shift ;
	my $xml_tag = shift ;
	my $exe = shift ;
	
	my $nb = 0 ;
	my $wp = new GrabInfo::WalkProc($this->{xml_tag}) ;
	$wp->start(sub {
		my $pid = shift ;
		if (open(STAT, "/proc/$pid/stat")){
			my $buf = <STAT> ;
			close(STAT) ;
			my $prog = (split(/\s+/, $buf))[1] ;
			if ($prog eq "($exe)"){
				$nb++ ;
			}			
		}
	}) ;

	$xml_tag->add_attr("nb", $nb) ;
}


1 ;
